Index: tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java
===================================================================
--- tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 541)
+++ tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 542)
@@ -1062,75 +1200,73 @@
 
 		p = parameters.get(ConcordancePreferences.LEFT_ANALYSIS_PROPERTIES);
 		if (p != null) {
-			if (p instanceof List<?>) this.pLeftAnalysisProperties = (List<Property>)p;
+			if (p instanceof List<?>) this.pAnalysisLeftProperties = (List<Property>)p;
 			else {
 				String v = p.toString();
-				this.pLeftAnalysisProperties = Concordance.stringToProperties(getCorpus(), v);
+				this.pAnalysisLeftProperties = Concordance.stringToProperties(getCorpus(), v);
 			}
 		}
 
 		p = parameters.get(ConcordancePreferences.RIGHT_ANALYSIS_PROPERTIES);
 		if (p != null) {
-			if (p instanceof List<?>) this.pRightAnalysisProperties = (List<Property>)p;
+			if (p instanceof List<?>) this.pAnalysisRightProperties = (List<Property>)p;
 			else {
 				String v = p.toString();
-				this.pRightAnalysisProperties = Concordance.stringToProperties(getCorpus(), v);
+				this.pAnalysisRightProperties = Concordance.stringToProperties(getCorpus(), v);
 			}
 		}
 
 		p = parameters.get(ConcordancePreferences.KEYWORD_ANALYSIS_PROPERTIES);
 		if (p != null) {
-			if (p instanceof List<?>) this.pKeywordAnalysisProperties = (List<Property>)p;
+			if (p instanceof List<?>) this.pAnalysisKeywordProperties = (List<Property>)p;
 			else {
 				String v = p.toString();
-				this.pKeywordAnalysisProperties = Concordance.stringToProperties(getCorpus(), v);
+				this.pAnalysisKeywordProperties = Concordance.stringToProperties(getCorpus(), v);
 			}
 		}
 
 		p = parameters.get(ConcordancePreferences.LEFT_VIEW_PROPERTIES);
 		if (p != null) {
-			if (p instanceof List<?>) this.pLeftCViewProperties = (List<Property>)p;
+			if (p instanceof List<?>) this.pViewLeftProperties = (List<Property>)p;
 			else {
 				String v = p.toString();
-				this.pLeftCViewProperties = Concordance.stringToProperties(getCorpus(), v);
+				this.pViewLeftProperties = Concordance.stringToProperties(getCorpus(), v);
 			}
 		}
 
 		p = parameters.get(ConcordancePreferences.RIGHT_VIEW_PROPERTIES);
 		if (p != null) {
-			if (p instanceof List<?>) this.pRightCViewProperties = (List<Property>)p;
+			if (p instanceof List<?>) this.pViewRightProperties = (List<Property>)p;
 			else {
 				String v = p.toString();
-				this.pRightCViewProperties = Concordance.stringToProperties(getCorpus(), v);
+				this.pViewRightProperties = Concordance.stringToProperties(getCorpus(), v);
 			}
 		}
 
 		p = parameters.get(ConcordancePreferences.KEYWORD_VIEW_PROPERTIES);
 		if (p != null) {
-			if (p instanceof List<?>) this.pKeywordViewProperties = (List<Property>)p;
+			if (p instanceof List<?>) this.pViewKeywordProperties = (List<Property>)p;
 			else {
 				String v = p.toString();
-				this.pKeywordViewProperties = Concordance.stringToProperties(getCorpus(), v);
+				this.pViewKeywordProperties = Concordance.stringToProperties(getCorpus(), v);
 			}
 		}
 
-		this.updateViewPropertiesList();
-
 		p = parameters.get(ConcordancePreferences.VIEW_REFERENCEPATTERN);
 		if (p != null) {
-			if (p instanceof ReferencePattern) this.pRefViewPattern = (ReferencePattern)p;
+			if (p instanceof ReferencePattern) this.pViewRefPattern = (ReferencePattern)p;
 			else {
 				String v = p.toString();
-				this.pRefViewPattern = Concordance.stringToReferencePattern(getCorpus(), v);
+				this.pViewRefPattern = Concordance.stringToReferencePattern(getCorpus(), v);
 			}
 		}
 
 		p = parameters.get(ConcordancePreferences.ANALYSIS_REFERENCEPATTERN);
 		if (p != null) {
-			if (p instanceof ReferencePattern) this.pRefAnalysePattern = (ReferencePattern)p;
+			if (p instanceof ReferencePattern) this.pAnalysisRefPattern = (ReferencePattern)p;
 			else {
 				String v = p.toString();
-				this.pRefAnalysePattern = Concordance.stringToReferencePattern(getCorpus(), v);
+				this.pAnalysisRefPattern = Concordance.stringToReferencePattern(getCorpus(), v);
 			}
 		}
 
@@ -1142,60 +1278,6 @@
 		return true;
 	}
 
-	private static ReferencePattern stringToReferencePattern(Corpus corpus, String v) {
-		try {
-			ReferencePattern props = new ReferencePattern();
-			if (v == null) return props;
-			if (v.length() == 0) return props;
-
-			String[] split = v.split("\t");
-			for (String s : split) {
-				if (s.contains("_")) {
-					String[] split2 = s.split("_", 2);
-					StructuralUnit su = corpus.getStructuralUnit(split2[0]);
-					if (su != null) {
-						Property prop = su.getProperty(split2[1]);
-						if (prop != null) {
-							props.addProperty(prop);
-						}
-					}
-				} else {
-					Property prop = corpus.getProperty(s);
-					if (prop != null) {
-						props.addProperty(prop);
-					}
-				}
-			}
-			return props;
-		} catch (Exception e) {
-			System.out.println("Error: "+v+" property not found in "+corpus);
-			return null;
-		}
-	}
-
-	private static List<Property> stringToProperties(Corpus corpus, String v)  {
-
-		ArrayList<Property> props = new ArrayList<Property>();
-		if (v == null) return props;
-		if (v.length() == 0) return props;
-
-		String[] split = v.split("\t");
-		for (String s : split) {
-			Property prop;
-			try {
-				prop = corpus.getProperty(s);
-			} catch (CqiClientException e) {
-				System.out.println("Error: "+v+" property not found in "+corpus);
-				Log.printStackTrace(e);
-				return null;
-			}
-			if (prop != null) {
-				props.add(prop);
-			}
-		}
-		return props;
-	}
-
 	/**
 	 * Set the reference Pattern.
 	 * 
@@ -1203,14 +1285,11 @@
 	 *            the new reference Pattern
 	 */
 	public void setRefAnalysePattern(ReferencePattern referencePattern) {
-		this.pRefAnalysePattern = referencePattern;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null));// we could make it less radically. But the data
-		// is cached anyway...
+		this.pAnalysisRefPattern = referencePattern;
+		updateDirty(pAnalysisRefPattern, referencePattern);
+		resetLines();
 	}
 
-
-
 	/**
 	 * Set the reference Pattern.
 	 * 
@@ -1218,10 +1297,9 @@
 	 *            the new reference Pattern
 	 */
 	public void setRefViewPattern(ReferencePattern referencePattern) {
-		this.pRefViewPattern = referencePattern;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null));// we could make it less radically. But the data
-		// is cached anyway...
+		this.pViewRefPattern = referencePattern;
+		updateDirty(pViewRefPattern, referencePattern);
+		resetLines();
 	}
 
 	/**
@@ -1231,9 +1309,9 @@
 	 *            the new analysis property
 	 */
 	public void setRightAnalysisProperties(List<Property> selectedRightSortProperty) {
-		this.pRightAnalysisProperties = selectedRightSortProperty;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null)); // empty lines
+		this.pAnalysisRightProperties = selectedRightSortProperty;
+		updateDirty(pAnalysisRightProperties, selectedRightSortProperty);
+		resetLines();
 	}
 
 	/**
@@ -1244,9 +1322,8 @@
 	 */
 	public void setRightContextSize(int size) {
 		this.pRightContextSize = size;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null));// we could make it less radically. But the data
-		// is cached anyway...
+		updateDirty(pRightContextSize, size);
+		resetLines();
 	}
 
 	/**
@@ -1256,13 +1333,11 @@
 	 *            the new view properties
 	 */
 	public void setViewProperties(List<Property> viewProperties) {
-		this.pViewProperties = viewProperties;
-		this.pLeftCViewProperties = viewProperties;
-		this.pRightCViewProperties = viewProperties;
-		this.pKeywordViewProperties = viewProperties;
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null));// we could make it less radically. But teh data
-		// is cached anyway...
+		this.pViewLeftProperties = viewProperties;
+		this.pViewRightProperties = viewProperties;
+		this.pViewKeywordProperties = viewProperties;
+		dirty = true;
+		resetLines();
 	}
 
 	/**
@@ -1281,24 +1356,22 @@
 			List<Property> keywordViewProperties) {
 		// reset list or use the given ones
 		if (leftCViewProperties != null)
-			this.pLeftCViewProperties = leftCViewProperties;
+			this.pViewLeftProperties = leftCViewProperties;
 		else
-			this.pLeftCViewProperties = new ArrayList<Property>();
+			this.pViewLeftProperties = new ArrayList<Property>();
 
 		if (rightCViewProperties != null)
-			this.pRightCViewProperties = rightCViewProperties;
+			this.pViewRightProperties = rightCViewProperties;
 		else
-			this.pRightCViewProperties = new ArrayList<Property>();
+			this.pViewRightProperties = new ArrayList<Property>();
 
 		if (keywordViewProperties != null)
-			this.pKeywordViewProperties = keywordViewProperties;
+			this.pViewKeywordProperties = keywordViewProperties;
 		else
-			this.pKeywordViewProperties = new ArrayList<Property>();
+			this.pViewKeywordProperties = new ArrayList<Property>();
 
-		this.updateViewPropertiesList();
-
-		this.lines = new ArrayList<Line>(Collections.nCopies(nLines, (Line) null));// we could make it less radically. But the data
-		// is cached anyway...
+		dirty = true;
+		resetLines();
 	}
 
 	/**
@@ -1325,6 +1398,7 @@
 		System.currentTimeMillis();
 	}
 
+
 	/**
 	 * To txt.
 	 *
@@ -1334,9 +1408,10 @@
 	 */
 	public boolean toTxt(File outfile, Format format) {
 		try {
-			this.writer = new BufferedWriter(new OutputStreamWriter(
+			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(
 					new FileOutputStream(outfile), "UTF-8")); //$NON-NLS-1$
 			toTxt(writer, 0, nLines - 1, format, "\t",""); //$NON-NLS-1$ //$NON-NLS-2$
+			writer.close();
 		} catch (Exception e) {
 			System.err.println(ConcordanceMessages.Concordance_12 + e);
 			Log.printStackTrace(e);
@@ -1363,20 +1438,24 @@
 	public boolean toTxt(File outfile, String encoding, String colseparator, String txtseparator) throws IOException {
 
 		// NK: writer declared as class attribute to perform a clean if the operation is interrupted
+		OutputStreamWriter writer = null;
 		try {
-			this.writer = new OutputStreamWriter(new BufferedOutputStream(new FileOutputStream(outfile)), encoding);
+			writer = new OutputStreamWriter(new BufferedOutputStream(new FileOutputStream(outfile)), encoding);
 			// if ("UTF-8".equals(encoding)) writer.write('\ufeff'); // UTF-8 BOM
 			toTxt(writer, 0, nLines - 1, colseparator, txtseparator);
 		} catch (Exception e) {
 			System.err.println(ConcordanceMessages.Concordance_12 + e.getLocalizedMessage());
 			Log.printStackTrace(e);
 			return false;
-		} 
+		} finally {
+			if (writer != null) {
+				writer.close();
+			}
+		}
 
 		return true;
 	}
 
-
 	/**
 	 * Write the lines between from and to on a writer.
 	 * 
@@ -1494,33 +1573,6 @@
 	}
 
 	/**
-	 * Update view properties list.
-	 */
-	private void updateViewPropertiesList() {
-		// reset view properties
-		this.pViewProperties = new ArrayList<Property>();
-		// fill it with the properties of the others
-		pViewProperties.addAll(pKeywordViewProperties);
-
-		for (Property p : pLeftCViewProperties) { // add the view properties of left context
-			if (!pViewProperties.contains(p)) {
-				pViewProperties.add(p);
-			}
-		}
-
-		for (Property p : pRightCViewProperties) { // add the view properties of right context
-			if (!pViewProperties.contains(p)) {
-				pViewProperties.add(p);
-			}
-		}
-	}
-
-	@Override
-	public boolean canCompute() {
-		return getCorpus() != null;
-	}
-
-	/**
 	 * The Enum Format.
 	 */
 	public enum Format {
@@ -1530,17 +1582,77 @@
 		CONTEXT
 	}
 
+	public void setNLinePerPage(Integer nLinesPerPage) {
+		this.pNLinesPerPage = nLinesPerPage;
+	}
+
+	public Integer getNLinePerPage() {
+		return pNLinesPerPage;
+	}
+
+	public Integer getTopIndex() {
+		return pTopIndex;
+	}
+
+	public List<Property> getAvailableKeywordViewProperties() {
+		return availableKeywordViewProperties;
+	}
+
+	public List<Property> getAvailableKeywordSortProperties() {
+		return availableKeywordSortProperties;
+	}
+
+	public String getLimitCQL() {
+		return pLimitCQL;
+	}
+
+	public List<Property> getAvailableLeftViewProperties() {
+		return availableLeftViewProperties;
+	}
+
+	public List<Property> getAvailableRightViewProperties() {
+		return availableRightViewProperties;
+	}
+
+	public void setLeftViewProperties(List<Property> selectedViewProperties) {
+		this.pViewLeftProperties = selectedViewProperties;
+		updateDirty(pViewLeftProperties, selectedViewProperties);
+	}
+
+	public void setRightViewProperties(List<Property> selectedViewProperties) {
+		this.pViewRightProperties = selectedViewProperties;
+		updateDirty(pViewRightProperties, selectedViewProperties);
+	}
+
+	public void setKeywordViewProperties(List<Property> selectedViewProperties) {
+		this.pViewKeywordProperties = selectedViewProperties;
+		updateDirty(pViewKeywordProperties, selectedViewProperties);
+	}
+
+	public List<Property> getAvailableLeftSortProperties() {
+		return this.availableLeftSortProperties;
+	}
+
+	public List<Property> getAvailableRightSortProperties() {
+		return this.availableRightSortProperties;
+	}
+
+	public void setQuery(Query query) {
+		this.pQuery = query;
+		updateDirty(pQuery, query);
+	}
+
 	/**
-	 * Brutal way to reset the concordance lines. they will be recomputed when getLines(...) is called
+	 * Update the dirty state by comparing an old parameter with a new
+	 * 
+	 * @param oldParameter may be null
+	 * @param newParameter may be null
 	 */
-	public void resetLines() {
-		lines = new ArrayList<Line>(Collections.nCopies(nLines,
-				(Line) null)); // empty lines
+	protected void updateDirty(Object oldParameter, Object newParameter) {
+		dirty = oldParameter == null || oldParameter.equals(newParameter);
 	}
 
-	@Override
-	public boolean saveParameters() {
-		// TODO Auto-generated method stub
-		return false;
+	public void setTopIndex(int i) {
+		pTopIndex = i;
 	}
 }
Index: tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Line.java
===================================================================
--- tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Line.java	(revision 541)
+++ tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Line.java	(revision 542)
@@ -54,24 +54,24 @@
 	private Concordance concordance;
 
 	/** The left ctx view properties. */
-	private Map<Property, List<String>> leftCtxViewProperties;
+	private Map<Property, List<String>> leftCtxViewPropertiesValues;
 	
 	/** The keywords view properties. */
-	private Map<Property, List<String>> keywordsViewProperties;
+	private Map<Property, List<String>> keywordsViewValues;
 	
 	/** The right ctx view properties. */
-	private Map<Property, List<String>> rightCtxViewProperties;
+	private Map<Property, List<String>> rightCtxViewValues;
 
 	/** The left ctx analysis property. */
-	private HashMap<Property, List<String>> leftCtxAnalysisProperty;
+	private HashMap<Property, List<String>> leftCtxAnalysisValues;
 	
 	/** The keywords analysis property. */
-	private HashMap<Property, List<String>> keywordsAnalysisProperty;
+	private HashMap<Property, List<String>> keywordsAnalysisValues;
 	
 	/** The right ctx analysis property. */
-	private HashMap<Property, List<String>> rightCtxAnalysisProperty;
+	private HashMap<Property, List<String>> rightCtxAnalysisValues;
 	
-	/** The PRO p_ separtor. */
+	/** The proerty values separator. */
 	public static String PROP_SEPARTOR ="_"; //$NON-NLS-1$
 
 	/** The references : view and sort */
@@ -101,12 +101,12 @@
 	 * @param concordance the concordance
 	 * @param keywordsIdValues the keywords id values
 	 * @param textId the text id
-	 * @param leftCtxViewProperty the left context view property values
-	 * @param keywordsViewProperty the keywords view property values
-	 * @param rightCtxViewProperty the right context view property values
-	 * @param lineLeftCtxAnaPropValue the left context analysis property values
-	 * @param lineKeywordsAnaPropValue the keywords analysis property values
-	 * @param lineRightCtxAnaPropValue the right context analysis property values
+	 * @param leftCtxViewPropertiesValues the left context view property values
+	 * @param keywordsViewValues the keywords view property values
+	 * @param rightCtxViewValues the right context view property values
+	 * @param leftCtxAnalysisValues the left context analysis property values
+	 * @param keywordsAnalysisValues the keywords analysis property values
+	 * @param rightCtxAnalysisValues the right context analysis property values
 	 * @param refView the view references
 	 * @param reference2 the sort references
 	 * @param matchs the matchs
@@ -114,23 +114,23 @@
 	 * @param annotationValue 
 	 */
 	public Line(Concordance concordance, List<String> keywordsIdValues,
-			String textId, Map<Property, List<String>> leftCtxViewProperty,
-			Map<Property, List<String>> keywordsViewProperty,
-			Map<Property, List<String>> rightCtxViewProperty,
-			HashMap<Property, List<String>> lineLeftCtxAnaPropValue,
-			HashMap<Property, List<String>> lineKeywordsAnaPropValue,
-			HashMap<Property, List<String>> lineRightCtxAnaPropValue, Reference refView,
+			String textId, Map<Property, List<String>> leftCtxViewPropertiesValues,
+			Map<Property, List<String>> keywordsViewValues,
+			Map<Property, List<String>> rightCtxViewValues,
+			HashMap<Property, List<String>> leftCtxAnalysisValues,
+			HashMap<Property, List<String>> keywordsAnalysisValues,
+			HashMap<Property, List<String>> rightCtxAnalysisValues, Reference refView,
 			Reference refAna, Match matchs, int targetpos) {
 		this.textId = textId;
 		this.targetpos = targetpos;
 		this.keywordsIdValues = keywordsIdValues;
 		this.concordance = concordance;
-		this.leftCtxViewProperties = leftCtxViewProperty;
-		this.keywordsViewProperties = keywordsViewProperty;
-		this.rightCtxViewProperties = rightCtxViewProperty;
-		this.leftCtxAnalysisProperty = lineLeftCtxAnaPropValue;
-		this.keywordsAnalysisProperty = lineKeywordsAnaPropValue;
-		this.rightCtxAnalysisProperty = lineRightCtxAnaPropValue;
+		this.leftCtxViewPropertiesValues = leftCtxViewPropertiesValues;
+		this.keywordsViewValues = keywordsViewValues;
+		this.rightCtxViewValues = rightCtxViewValues;
+		this.leftCtxAnalysisValues = leftCtxAnalysisValues;
+		this.keywordsAnalysisValues = keywordsAnalysisValues;
+		this.rightCtxAnalysisValues = rightCtxAnalysisValues;
 		this.refView = refView;
 		this.refAna = refAna;
 		this.match = matchs;
@@ -143,7 +143,7 @@
 	 * @return the keywords analysis property
 	 */
 	public HashMap<Property, List<String>> getKeywordsAnalysisProperty() {
-		return keywordsAnalysisProperty;
+		return keywordsAnalysisValues;
 	}
 	
 	/**
@@ -152,7 +152,7 @@
 	 * @return the left context analysis property
 	 */
 	public HashMap<Property, List<String>> getLeftAnalysisProperty() {
-		return leftCtxAnalysisProperty;
+		return leftCtxAnalysisValues;
 	}
 
 	/**
@@ -161,7 +161,7 @@
 	 * @return the right ctx analysis property
 	 */
 	public HashMap<Property, List<String>> getRightAnalysisProperty() {
-		return rightCtxAnalysisProperty;
+		return rightCtxAnalysisValues;
 	}
 
 	/**
@@ -170,7 +170,7 @@
 	 * @return the keywords view properties
 	 */
 	public Map<Property, List<String>> getKeywordsViewProperties() {
-		return keywordsViewProperties;
+		return keywordsViewValues;
 	}
 
 	/**
@@ -179,7 +179,7 @@
 	 * @return the left context view properties
 	 */
 	public Map<Property, List<String>> getLeftCtxViewProperties() {
-		return leftCtxViewProperties;
+		return leftCtxViewPropertiesValues;
 	}
 
 	/**
@@ -188,7 +188,7 @@
 	 * @return the right context view properties
 	 */
 	public Map<Property, List<String>> getRightCtxViewProperties() {
-		return rightCtxViewProperties;
+		return rightCtxViewValues;
 	}
 
 	/**
@@ -216,7 +216,7 @@
 	 * @return the left context size
 	 */
 	public int getLeftContextSize() {
-		return leftCtxViewProperties.values().iterator().next().size();
+		return leftCtxViewPropertiesValues.values().iterator().next().size();
 	}
 
 	/**
@@ -225,7 +225,7 @@
 	 * @return the keywords size
 	 */
 	public int getKeywordsSize() {
-		return keywordsViewProperties.values().iterator().next().size();
+		return keywordsViewValues.values().iterator().next().size();
 	}
 
 	/**
@@ -234,7 +234,7 @@
 	 * @return the right context size
 	 */
 	public int getRightContextSize() {
-		return rightCtxViewProperties.values().iterator().next().size();
+		return rightCtxViewValues.values().iterator().next().size();
 	}
 
 	/**
@@ -245,54 +245,8 @@
 	public Match getMatch() {
 		return match;
 	}
-
+	
 	/**
-	 * Used by leftContextToString, keywordsToString and rightContextToString to
-	 * build te string they return.
-	 *
-	 * @param values A map returned by getLeftCtxViewProperties,
-	 * getKeywordsViewProperties or getRightCtxViewProperties
-	 * @param propertySeparator The string used to separate the dif ferent view properties for
-	 * each word
-	 * @param wordSeparator The string used to separate the dif ferent words
-	 * @return The string representation
-	 */
-	private String fieldToString(Map<Property, List<String>> values,
-			String propertySeparator, String wordSeparator) {
-		List<String> words = new ArrayList<String>();
-		for (int i = 0; i < values.get(concordance.getViewProperties().get(0))
-				.size(); i++) {
-			List<String> word = new ArrayList<String>();
-			for (Property property : concordance.getViewProperties())
-				word.add(values.get(property).get(i));
-			words.add(StringUtils.join(word, propertySeparator));
-		}
-		return LangFormater.format(StringUtils.join(words, wordSeparator),
-				concordance.getCorpus().getAttribute("lang")); //$NON-NLS-1$
-	}
-
-	/**
-	 * Fix spaces.
-	 *
-	 * @param str the str
-	 * @return the string
-	 */
-	private String fixSpaces(String str) {
-		str = str.replace(" ' ", " '"); //$NON-NLS-1$ //$NON-NLS-2$
-		str = str.replace("' ", "'"); //$NON-NLS-1$ //$NON-NLS-2$
-		str = str.replace(" , ", ", "); //$NON-NLS-1$ //$NON-NLS-2$
-		str = str.replace(" \" ", " \""); //$NON-NLS-1$ //$NON-NLS-2$
-		str = str.replace(" . ", ". "); //$NON-NLS-1$ //$NON-NLS-2$
-		str = str.replace("( ", "("); //$NON-NLS-1$ //$NON-NLS-2$
-		str = str.replace(" )", ")"); //$NON-NLS-1$ //$NON-NLS-2$
-		str = str.replace("[ ", "["); //$NON-NLS-1$ //$NON-NLS-2$
-		str = str.replace(" ]", "]"); //$NON-NLS-1$ //$NON-NLS-2$
-		str = str.replace("{ ", "{"); //$NON-NLS-1$ //$NON-NLS-2$
-		str = str.replace(" }", "}"); //$NON-NLS-1$ //$NON-NLS-2$
-		return str;
-	}
-
-	/**
 	 * Returns a string representing the left context.
 	 *
 	 * @param propertySeparator The string used to separate the dif ferent view properties for
@@ -326,9 +280,14 @@
 		int start = this.getLeftContextSize() - max;
 		for (int i = start; i < this.getLeftContextSize(); i++) {
 			List<String> word = new ArrayList<String>();
-			for (Property property : concordance.getLeftViewProperties())
-				word.add(values.get(property).get(i));
-			
+			for (Property property : concordance.getLeftViewProperties()) {
+				List<String> ivalues = values.get(property);
+				if (ivalues == null) {
+					System.out.println("ERROR: null ivalues in "+values+" for property "+property);
+				} else {
+					word.add(ivalues.get(i));
+				}
+			}
 			words.add(StringUtils.join(word, propertySeparator));
 			
 			if (decorator != null) {
@@ -340,8 +299,6 @@
 
 		return LangFormater.format(StringUtils.join(words, wordSeparator),
 				concordance.getCorpus().getAttribute("lang")); //$NON-NLS-1$
-		// return fieldToString(getLeftCtxViewProperties(), propertySeparator,
-		// wordSeparator);
 	}
 
 	/**
@@ -392,8 +349,6 @@
 		}
 		return LangFormater.format(StringUtils.join(words, wordSeparator),
 				concordance.getCorpus().getAttribute("lang")); //$NON-NLS-1$
-		// return fieldToString(getKeywordsViewProperties(), propertySeparator,
-		// wordSeparator);
 	}
 
 	/**
@@ -441,8 +396,6 @@
 		}
 		return LangFormater.format(StringUtils.join(words, wordSeparator),
 				concordance.getCorpus().getLang()); 
-		// return fieldToString(getRightCtxViewProperties(), propertySeparator,
-		// wordSeparator);
 	}
 	
 	/** The properties to process. */
@@ -533,8 +486,6 @@
 
 		return LangFormater.format(StringUtils.join(words, " "), //$NON-NLS-1$
 				concordance.getCorpus().getAttribute("lang")); //$NON-NLS-1$
-		// return fieldToString(getLeftCtxViewProperties(), propertySeparator,
-		// wordSeparator);
 	}
 
 	/**
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/ComputeTXMResult.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/ComputeTXMResult.java	(revision 541)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/ComputeTXMResult.java	(revision 542)
@@ -18,6 +18,7 @@
 		}
 		
 		TXMEditorPart editor = (TXMEditorPart)page;
+		editor.getResultData().setDirty(); //TODO: MD: I had to add this to recompute the concordance when the query field has been modified
 		editor.compute(true);
 		
 		return null;
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/handlers/BaseAbstractHandler.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/handlers/BaseAbstractHandler.java	(revision 541)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/handlers/BaseAbstractHandler.java	(revision 542)
@@ -30,6 +30,7 @@
 	 */
 	public boolean checkStatsEngine()	{
 		if (!RStatsEngine.isStarted()) {
+			System.out.println(RCoreMessages.error_statsEngineNotReadyCancelingCommand);
 			Log.severe(RCoreMessages.error_statsEngineNotReadyCancelingCommand);
 			return false;
 		}
@@ -43,6 +44,7 @@
 	 */
 	public boolean checkCorpusEngine()	{
 		if (!CQPEngine.isInitialized())	{
+			System.out.println("Corpus Engine is not ready, canceling command.");
 			Log.severe("Corpus Engine is not ready, canceling command.");
 			return false;
 		}
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditorPart.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditorPart.java	(revision 541)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditorPart.java	(revision 542)
@@ -192,7 +192,8 @@
 	@Override
 	public boolean isDirty() {
 		if (getResultData() != null) {
-			return getResultData().isDirty();
+			// if the result has never been computed, the editor is not dirty ->  no * shown
+			return getResultData().isDirty() && getResultData().getHasBeenComputedOnce();
 		}
 		
 		return false;
@@ -285,13 +286,9 @@
 		return this.getEditorInput().getResult().getStringParameterValue(key);
 	}
 
-	
-	
-	public void compute(boolean update) {
+	public final void compute(boolean update) {
 		compute(this.getResultData(), update, this);
 	}
-
-
 	
 	public static void compute(final TXMResult result)	{
 		compute(result, false, null);
@@ -318,7 +315,6 @@
 		    	this.runInit(monitor);
 		    	
 		    	try {
-
 		    		JobsTimer.start();
 		    		
 		    		// computing result
@@ -329,7 +325,7 @@
 //						result.loadParameters();
 //					}
 					
-					if(!result.compute(update, monitor))	{
+					if (!result.compute(update, monitor))	{
 						return Status.CANCEL_STATUS;
 					}
 
@@ -341,13 +337,14 @@
 //					}
 
 					// refreshing the tree node
-					if(editor != null)	{
-//						System.out.println(message);
-//						StatusLine.setMessage(message);
-						
-						editor.refresh(update);
+					if (editor != null)	{
+						this.syncExec(new Runnable() {
+							@Override
+							public void run() {
+								editor.refresh(update);
+							}
+						});
 					}
-					
 				}
 		    	// for user direct canceling
 		    	catch(ThreadDeath td) {
@@ -449,7 +446,7 @@
 	 * Synchronizes the editor with the result and refreshes the corpus view.
 	 * Also fires a dirty property change.
 	 */
-	public void refresh()	{
+	public final void refresh()	{
 		this.refresh(false);
 	}
 	
Index: tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/vlcplayer/VLCPlayerEditor.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/vlcplayer/VLCPlayerEditor.java	(revision 541)
+++ tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/editors/vlcplayer/VLCPlayerEditor.java	(revision 542)
@@ -62,14 +62,6 @@
 	}
 
 	/* (non-Javadoc)
-	 * @see org.eclipse.ui.part.EditorPart#isDirty()
-	 */
-	@Override
-	public boolean isDirty() {
-		return false;
-	}
-
-	/* (non-Javadoc)
 	 * @see org.eclipse.ui.part.EditorPart#isSaveAsAllowed()
 	 */
 	@Override
